# viz.js-cli-wrapper

[![Build status](https://img.shields.io/travis/jeysal/viz.js-cli-wrapper.svg?style=flat-square)](https://travis-ci.org/jeysal/viz.js-cli-wrapper)
[![AppVeyor](https://img.shields.io/appveyor/ci/jeysal/viz-js-cli-wrapper.svg?style=flat-square)](https://ci.appveyor.com/project/jeysal/viz-js-cli-wrapper)
[![Code coverage](https://img.shields.io/codecov/c/github/jeysal/viz.js-cli-wrapper.svg?style=flat-square)](https://codecov.io/gh/jeysal/viz.js-cli-wrapper)
[![License](https://img.shields.io/github/license/jeysal/viz.js-cli-wrapper.svg?style=flat-square)](https://github.com/jeysal/viz.js-cli-wrapper/blob/master/LICENSE)

A command line interface wrapped around [viz.js](https://github.com/mdaines/viz.js).

Provides a cross-platform way to use core GraphViz features with similar command line syntax.

## Installation

### npm

You can install it using [Node.js](https://nodejs.org/) and [npm](https://www.npmjs.com/), globally on your system

    npm install -g viz.js-cli-wrapper

or locally for your package

    npm install --save viz.js-cli-wrapper

## Usage

### Executables

The package provides six GraphViz-like executables:  
* `circo`
* `dot`
* `fdp`
* `neato`
* `osage`
* `twopi`

If you chose to install globally, npm should have already made them available on your PATH so you can run them everywhere.  
If you need to locate them, `npm bin -g` will point you to their location (usually `/usr/bin`, or `%APPDATA%/npm` on Windows).

If you installed locally, running `npm bin` in your package will print their location, usually `node_modules/.bin`.

### Command-line interface

The command line interface is very similar to that of GraphViz itself, however, options are limited as viz.js does not support the whole range of GraphViz' features.
The following GraphViz options are currently supported:
* `-K`
* `-T`
* `-V`
* `-o`
* input files

For the full help text containing further information, run any of the executables with the `-h` flag, e.g. `dot -h`.

### Exit codes

* `70` - failed to read an input file
* `80` - failed to write to the output file

All other exit codes indicate invalid CLI usage or rendering errors from viz.js.

## Credits

A huge thanks to [Mike Daines](https://github.com/mdaines) for making GraphViz to some extent portable with [viz.js](https://github.com/mdaines/viz.js)!

## License

viz.js-cli-wrapper is [MIT-licensed](https://github.com/jeysal/viz.js-cli-wrapper/blob/master/LICENSE).
